

bool inestable (short a, short b, short c, short i)
{
	short num_ady;

	num_ady=bit(a,i)+bit(c,i)+bit(a,i+1)+bit(b,i+1)+bit(c,i+1);
	if (i>0) num_ady=num_ady+bit(a,i-1)+bit(b,i-1)+bit(c,i-1);

	if (bit(b,i)==0)
	{
		return (num_ady==3);
	}
	else
	{
		return ((num_ady<2)||(num_ady>3));
	}
}


// coste (x,n) -> bits en x desde 0 hasta n+1 (total n+2 bits)
//                los bits n y n+1 son valores de la columna central de 2xN
//                si algun bit desde 0 hasta n inestable -> infinito
//                sino:
//                      si cotas=true,  numero de 0's de los bits 0..n
//                      si cotas=false, numero de 0's de los bits 0..n-1
//


unsigned char coste_unario (short ac)
{
	short j;

	for (j=1;j<=M;j++) if (inestable(0,0,ac,j)) return infinito;
	// tambien es valido ^inestable(ac,0,0,j)^
	return 0;
}


unsigned char coste_binario_1 (short b, short c, bool sim, bool cotas)
{
	short j,mascara;

	for (j=0;j<=M;j++) if (inestable(0,b,c,j)) return infinito;

	if ((sim)||(cotas))
	{
		mascara=(1<<(M+1))-1;
		return (ceros(b&mascara,M+1));
	}
	else
	{
		mascara=(1<<M)-1;
		return (ceros(b&mascara,M));
	}
}


short coste_binario_n (short a, short b, bool sim, bool cotas)
{
	short j,mascara;

	for (j=0;j<=M;j++) if (inestable(a,b,0,j)) return infinito;

	if ((sim)||(cotas))
	{
		mascara=(1<<(M+1))-1;
		return (ceros(b&mascara,M+1));
	}
	else
	{
		mascara=(1<<M)-1;
		return (ceros(b&mascara,M));
	}
}

// no se usa
unsigned char coste_ternario (short a, short b, short c)
{
	short j,mascara;

	if ((bit(a,0)==bit(b,0))&&(bit(b,0)==bit(c,0))&&(bit(c,0)==1)) return infinito;

	for (j=0;j<=M;j++) if (inestable(a,b,c,j)) return infinito;

	mascara=(1<<M)-1;
	return (ceros(b&mascara,M));
}
