

short bit (int num, short n_bit)
{
	// 876543210
	if ( (num&(1<<(n_bit)))!=0 ) return 1;
	else return 0;
}


unsigned char ceros (short a, short n)
{
	short i;

	i=0;
	while (a>0)
	{
		i=i+(a&1);
		a=a>>1;
	}
	return (n-i);
}


unsigned int invertir (unsigned int num, short bits)
{
	unsigned int inv;

	inv=0;
	while (bits>0)
	{
		inv=(inv<<1)+(num&1);
		num=num>>1;
		bits--;
	}

	return inv;
}


unsigned int juntar (unsigned short a, unsigned short b, short bits)
{
	int num;
	short i;

	num=0;
	i=0;
	while (bits>0)
	{
		num = num+ (( ((a&1)<<1)+(b&1) )<<i);
		i=i+2;
		a=a>>1;
		b=b>>1;
		bits--;
	}

	return num;
}


int Kb (int bytes)
{
	return ((bytes+512)>>10);
}


short Mb (int bytes)
{
	return ((bytes+524288)>>20);
}


bool reja_estable (int sol[N])
{
	bool estable;
	short num,i,j;

	estable=true;
	j=0;
	while ((estable)&&(j<N))
	{
		i=0;
		while ((estable)&&(i<N))
		{
			num=0;
			if ((j>0)&&(i>0)&&(bit(sol[j-1],i-1)==1)) num++;
			if ((j>0)&&(bit(sol[j-1],i)==1)) num++;
			if ((j>0)&&(i<N-1)&&(bit(sol[j-1],i+1)==1)) num++;
			if ((i>0)&&(bit(sol[j],i-1)==1)) num++;
			if ((i<N-1)&&(bit(sol[j],i+1)==1)) num++;
			if ((j<N-1)&&(i>0)&&(bit(sol[j+1],i-1)==1)) num++;
			if ((j<N-1)&&(bit(sol[j+1],i)==1)) num++;
			if ((j<N-1)&&(i<N-1)&&(bit(sol[j+1],i+1)==1)) num++;

			if ((bit(sol[j],i)==1)&&(num!=2)&&(num!=3)) estable=false;
			else if ((bit(sol[j],i)==0)&&(num==3)) estable=false;
			i++;
		}
		j++;
	}

	return estable;
}


short extrae (char t[24], short ini, short fin)
{
	char s[25];
	short i;

	for (i=ini;i<=fin;i++)
	{
		s[i-ini]=t[i];
	}
	s[fin-ini+1]=(char)0;

	return (atoi(s));
}


bool cadena_igual (char s[], char cmp[3])
{
	short i;

	for (i=0;i<=2;i++)
	{
		if (s[i]!=cmp[i]) return (false);
	}
	return (true);
}


#if (tipo_medicion_tiempo==1)

	tiempo tiempo_transcurrido (struct tms buf)
	{
		tiempo t;
		int tt;

		tt=buf.tms_utime/100;
		t.totales_seg=tt;
		t.seg=tt%60;
		tt=tt/60;
		t.min=tt%60;
		tt=tt/60;
		t.horas=tt%24;
		t.dias=tt/24;

		return (t);
	}

#elif (tipo_medicion_tiempo==2)

	tiempo tiempo_transcurrido (time_t t1, time_t t2)
	{
		short i;
		char s[2][24];
		char *ss;
		char mes[2][4];
		short any[2];
		int tt;
		tiempo tie[2];
		tiempo resul;

		// la funcion difftime no funciona correctamente en todos los compiladores
		ss=ctime(&t1);
		for (i=0;i<24;i++) s[0][i]=ss[i];
		ss=ctime(&t2);
		for (i=0;i<24;i++) s[1][i]=ss[i];

		for (i=0;i<=1;i++)
		{
			// ao
			any[i]=extrae(s[i],20,23);
			// mes
			mes[i][0]=s[i][4];
			mes[i][1]=s[i][5];
			mes[i][2]=s[i][6];

			if (cadena_igual(mes[i],"Jan")) tie[i].dias=0;
			else if (cadena_igual(mes[i],"Feb")) tie[i].dias=31;
			else if (cadena_igual(mes[i],"Mar")) tie[i].dias=59;
			else if (cadena_igual(mes[i],"Apr")) tie[i].dias=90;
			else if (cadena_igual(mes[i],"May")) tie[i].dias=120;
			else if (cadena_igual(mes[i],"Jun")) tie[i].dias=151;
			else if (cadena_igual(mes[i],"Jul")) tie[i].dias=181;
			else if (cadena_igual(mes[i],"Aug")) tie[i].dias=212;
			else if (cadena_igual(mes[i],"Sep")) tie[i].dias=243;
			else if (cadena_igual(mes[i],"Oct")) tie[i].dias=273;
			else if (cadena_igual(mes[i],"Nov")) tie[i].dias=304;
			else if (cadena_igual(mes[i],"Dec")) tie[i].dias=334;

			if ((any[i]%4==0)&&(!cadena_igual(mes[i],"Jan"))&&(!cadena_igual(mes[i],"Feb"))) tie[i].dias++; // bisiesto
			// dia
			tie[i].dias=tie[i].dias+extrae(s[i],8,9);
			// hora
			tie[i].horas=extrae(s[i],11,12);
			// minuto
			tie[i].min=extrae(s[i],14,15);
			// segundo
			tie[i].seg=extrae(s[i],17,18);
			// segundos totales
			tie[i].totales_seg=((tie[i].dias*24+tie[i].horas)*60+tie[i].min)*60+tie[i].seg;
		}

		if (any[1]==any[0]+1)
		{
			if (any[0]%4==0) tie[1].totales_seg+=(unsigned)366*24*60*60;
			else tie[1].totales_seg+=(unsigned)365*24*60*60;
		}
		
		tt = tie[1].totales_seg-tie[0].totales_seg;

		resul.totales_seg=tt;
		resul.seg=tt%60;
		tt=tt/60;
		resul.min=tt%60;
		tt=tt/60;
		resul.horas=tt%24;
		resul.dias=tt/24;

		return (resul);
	}

#endif


int contar2 (short n, short j, short a, short b)
{
	// cuenta el numero de combinaciones factibles de vida en 2 filas
	// Resulta ser O(3,7278^n)
	// Primera llamada: j=0, a=0, b=0
	// Pre: n<=16, si no el resultado tendra ms de 32 bits
	int num;

	if (j==n)
	{
		return 1;
	}
	else
	{
		num = contar2(n,j+1,b,0);
		if (a+b<4)
		{
			num = num + (contar2(n,j+1,b,1)<<1);
			if (a+b<3)
			{
				num = num + contar2(n,j+1,b,2);
			}
		}

		return num;
	}
}


unsigned int contar3 (short n, short j, bool val[8][8][8], short a, short b)
{
	// cuenta el numero de combinaciones factibles de vida en 3 filas
	// Resulta ser O(4,73^n)
	// Primera llamada: j=0, a=0, b=0, val=calcular_validaciones_3x3
	// Pre: n<=14, si no el resultado tendra ms de 32 bits
	unsigned int num;
	short i;

	if (j==n)
	{
		return 1;
	}
	else
	{
		num=0;
		if (((a&1)==(a&4)>>2)&&((b&1)==(b&4)>>2))
		{
			if (val[a][b][1]) num=num+(contar3(n,j+1,val,b,1)<<1); // eq. a contar(n,j+1,4)
			if (val[a][b][3]) num=num+(contar3(n,j+1,val,b,3)<<1); // eq. a contar(n,j+1,6)

			if (val[a][b][0]) num=num+contar3(n,j+1,val,b,0);
			if (val[a][b][2]) num=num+contar3(n,j+1,val,b,2);
			if (val[a][b][5]) num=num+contar3(n,j+1,val,b,5);
			if (val[a][b][7]) num=num+contar3(n,j+1,val,b,7);
		}
		else
		{
			for (i=0;i<=7;i++) if (val[a][b][i]) num=num+contar3(n,j+1,val,b,i);
		}

		return num;
	}
	// usar printf ("%u",num) para ver el resultado de n=14
}
