

void exterior (bool r[N][N])
{
	// O(n) 
	short h,i,j,k,l,modulo,incx,incy;
	bool fin;
	short pos_ini=0;

	fin=false;
	i=pos_ini;
	j=pos_ini;
	modulo=N%3;
	l=(N-2)/3;
	if (modulo==1) l--;
	if (modulo==1) i=i+3;
	incx=3;
	incy=0;
	while (!fin)
	{
		for (k=1;k<=l;k++)
		{
			r[j][i]=true;
			r[j][i+1]=true;
			r[j+1][i]=true;
			r[j+1][i+1]=true;
			i=i+incx;
			j=j+incy;
			if (modulo==0)
			{
				if ((incx==3)&&(i==6+pos_ini)) i++;
				else if ((incy==3)&&(j==N-6+pos_ini)) j++;
				else if ((incx==-3)&&(i==N-8+pos_ini)) i--;
				else if ((incy==-3)&&(j==4+pos_ini)) j--;
			}
		}
		if (modulo==1)
		{
			if (incx==3)
			{
				r[j][i]=true;
				for (h=0;h<=2;h++) r[j+h*3][i+3]=true;
				for (h=0;h<=3;h++) r[j+1][i+h]=true;
				for (h=3;h<=6;h++) r[j+h][i+2]=true;
				i=i+2;
				j=j+8;
			}
			else if (incy==3)
			{
				i=i-3;
				j=j-3;
			}
			else if (incx==-3)
			{
				r[j+1][i+1]=true;
				for (h=0;h<=2;h++) r[j+1-h*3][i-2]=true;
				for (h=-2;h<=1;h++) r[j][i+h]=true;
				for (h=2;h<=5;h++) r[j-h][i-1]=true;
				i=i-2;
				j=j-8;
			}
		}
		if (incx==3) { incx=0; incy=3; }
		else if (incx==-3) { incx=0; incy=-3; }
		else if (incy==3) { incx=-3; incy=0; }
		else fin=true;
	}
}


void interior (bool r[N][N])
{
	// O(n)
	short h1,h2,k;
	short pos_ini=0;

	h1=pos_ini+3;
	h2=N-4+pos_ini;
	while ((h2-h1>4)||(h2-h1==3)||(h2-h1==1)) 
	{
		for (k=h1;k<h2;k++)
		{
			r[h1][k]=true;
			r[k][h2]=true;
			r[h2][k+1]=true;
			r[k+1][h1]=true;
		}
		h1=h1+2;
		h2=h2-2;
	}
	k=h2-h1;
	if (k==2)
	{	// n mod 4 == 1
		r[h1][h1]=true;
		r[h1][h1+1]=true;
		r[h1+1][h1]=true;
		r[h1+1][h2]=true;
		r[h2][h1+1]=true;
		r[h2][h2]=true;
	}
	else if (k==4)
	{	// n mod 4 == 3
		k=h1;
		for (h1=0;h1<=1;h1++)
			for (h2=0;h2<=1;h2++)
			{
				r[k+3*h1][k+3*h2]=true;
				r[k+3*h1][k+3*h2+1]=true;
				r[k+3*h1+1][k+3*h2]=true;
				r[k+3*h1+1][k+3*h2+1]=true;
			}
	}
}


short solucion_voraz (int sol[N])
{
	short modulo,c,i,j;
	bool r[N][N];

	for (i=0;i<N;i++) sol[i]=0;

	if (N>=8)
	{
		modulo=N%6;

		if (modulo==0) c=-24;
		else if (modulo==1) c=-17;
		else if (modulo==2) c=8;
		else if (modulo==3) c=-33;
		else if (modulo==4) c=-8;
		else if (modulo==5) c=-1;

		for (j=0;j<N;j++) for (i=0;i<N;i++) r[j][i]=false;

		exterior(r);
		interior(r);

		for (j=0;j<N;j++)
			for (i=0;i<N;i++)
				if (r[j][i]) sol[j]=sol[j]+(1<<i);

		return N*N-(3*N*N + 2*N +c)/6;
	}
	else
	{
		return N*N;
	}
}
