void eliminar_variable_sim_n (mejor_extension_cota g_amp)
{
	short a,b,c,aa,bb,max_asig;
	unsigned char coste_min;
	int nf,fin_filas,ab;
	short col,ini_c,coste_ana_b;
	short num_filas,coste_ter,coste;

	max_asig=(1<<(M+1))-1;

	for (a=0;a<=max_asig;a++)
	{
		aa=((a&(1<<M))<<1)+a;
		for (b=0;b<=max_asig;b++)
		{
			bb=((b&(1<<M))<<1)+b;
			coste_min=infinito;
			ab=pos[aa][bb]; // elimina combinaciones invalidas (-1) de pares. A posiciones
			              // validas les asigna indices consecutivos
			if (ab>=0)
			{
				coste_ana_b=1-(b>>M); //los costes ternarios de la estructura de trios
				                      //validos no tienen aadido el coste de la celda
				                      //central
				for (col=0;col<=3;col=col+3)// Miro combinaciones validos con las 2 posibles
				{                           // combinaciones de 2 celdas centrales
					if (col==0) ini_c=0;
					else if (col==3) ini_c=3<<M;

					num_filas=t_validos[col][ab].num_filas;

					if (num_filas>0)
					{
						coste_ter = coste_ana_b + t_validos[col][ab].coste_ter;
						nf = t_validos[col][ab].apunt;
						fin_filas = nf+num_filas;
						do
						{
							c=filas[nf]+ini_c;
							coste = coste_ter + costeB1[c][bb] + costeU[c];
							nf++;
							if (coste<coste_min)
							{
								coste_min=coste;
							}
						}
						while (nf<fin_filas);
					}
				}
			}
			g_amp[N-4][ab]=(unsigned char)coste_min;
		}
	}
}


void eliminar_variable_sim (short i, mejor_extension_cota g_amp)
{
	short a,b,c,aa,bb,max_asig;
	unsigned char coste_min;
	int nf,fin_filas,ab,bc;
	short col,ini_c,coste_ana_b;
	short num_filas,coste_ter,coste;

	max_asig=(1<<(M+1))-1;

	for (a=0;a<=max_asig;a++)
	{
		aa=((a&(1<<M))<<1)+a;
		for (b=0;b<=max_asig;b++)
		{
			bb=((b&(1<<M))<<1)+b;
			coste_min=infinito;
			ab=pos[aa][bb]; // elimina combinaciones invalidas (-1) de pares. A posiciones
			                // validas les asigna indices consecutivos
			if (ab>=0)
			{
				coste_ana_b=1-(b>>M); //los costes ternarios de la estructura de trios
				                          //validos no tienen aadido el coste de la celda
				                          //central
				for (col=0;col<=3;col=col+3)// Miro combinaciones validos con las 2 posibles
				{                           // combinaciones de 2 celdas centrales
					if (col==0) ini_c=0;
					else if (col==3) ini_c=3<<M;

					num_filas=t_validos[col][ab].num_filas;

					if (num_filas>0)
					{
						coste_ter = coste_ana_b + t_validos[col][ab].coste_ter;
						nf = t_validos[col][ab].apunt;
						fin_filas = nf+num_filas;
						do
						{
							c=filas[nf]+ini_c;
							bc=pos[bb][c];
							nf++;
							if (bc>=0)
							{
								coste=coste_ter+g_amp[i-3][bc];
								if (coste<coste_min)
								{
									coste_min=coste;
								}
							}
						}
						while (nf<fin_filas);
					}
				}
			}
			g_amp[i-4][ab]=(unsigned char)coste_min;
		}
	}
}



short encontrar_mejores_2_filas_centrales_sim (mejor_extension_cota g_amp,
                                               short *min_a, short *min_b)
{
	short a,b,c,aa,bb,i,max_asig;
	unsigned char coste_min;
	int nf,fin_filas,ab,ba;
	short col,ini_c,coste_b,coste_ana_b;
	short num_filas,coste_ter,coste;

	max_asig=(1<<(M+1))-1;
	coste_min=infinito;
	i=(N>>1)-2;

	for (a=0;a<=max_asig;a++)
	{
		aa=((a&(1<<M))<<1)+a;
		for (b=0;b<=max_asig;b++)
		{
			bb=((b&(1<<M))<<1)+b;
			ab=pos[aa][bb]; // elimina combinaciones invalidas (-1) de pares. A posiciones
						    // validas les asigna indices consecutivos
			if (ab>=0)
			{
				ba=pos[bb][aa];
				if (g_amp[i][ab]+g_amp[i][ba]<coste_min)
				{
					coste_min=g_amp[i][ab]+g_amp[i][ba];
					*min_a=aa;
					*min_b=bb;
				}
			}
		}
	}

	return (coste_min+coste_min);
}


short recup_sol (short i, short a, short b, bool abajo, mejor_extension_cota g_amp)
{
	short c,c_min,max_asig,ii;
	unsigned char coste_min;
	int nf,fin_filas,ab,bc;
	short col,ini_c,coste_ana_b;
	short num_filas,coste_ter,coste;

	max_asig=(1<<(M+1))-1;
	if (abajo) ii=i-2;
	else ii=N-3-i;

	coste_min=infinito;
	ab=pos[a][b];	// elimina combinaciones invalidas (-1) de pares. A posiciones
					// validas les asigna indices consecutivos
	coste_ana_b=1-(b>>(M+1)); //los costes ternarios de la estructura de trios
                              //validos no tienen aadido el coste de la celda
                              //central
	for (col=0;col<=3;col=col+3)// Miro combinaciones validos con las 2 posibles
	{                           // combinaciones de 2 celdas centrales
		if (col==0) ini_c=0;
		else if (col==3) ini_c=3<<M;

		num_filas=t_validos[col][ab].num_filas;

		coste_ter = coste_ana_b + t_validos[col][ab].coste_ter;
		nf = t_validos[col][ab].apunt;
		fin_filas = nf+num_filas;
		do
		{
			c=filas[nf]+ini_c;
			bc=pos[b][c];
			nf++;
			if (bc>=0)
			{
				coste=coste_ter+g_amp[ii][bc];
				if (coste<coste_min)
				{
					c_min=c;
					coste_min=coste;
				}
			}
		}
		while (nf<fin_filas);
	}

	return c_min;
}


short recup_sol_n (short a, short b)
{
	short c,c_min,max_asig;
	unsigned char coste_min;
	int nf,fin_filas,ab,bc;
	short col,ini_c,coste_ana_b;
	short num_filas,coste_ter,coste;

	max_asig=(1<<(M+1))-1;

	coste_min=infinito;
	ab=pos[a][b];	// elimina combinaciones invalidas (-1) de pares. A posiciones
					// validas les asigna indices consecutivos
	coste_ana_b=1-(b>>(M+1)); //los costes ternarios de la estructura de trios
                              //validos no tienen aadido el coste de la celda
                              //central
	for (col=0;col<=3;col=col+3)// Miro combinaciones validos con las 2 posibles
	{                           // combinaciones de 2 celdas centrales
		if (col==0) ini_c=0;
		else if (col==3) ini_c=3<<M;

		num_filas=t_validos[col][ab].num_filas;

		coste_ter = coste_ana_b + t_validos[col][ab].coste_ter;
		nf = t_validos[col][ab].apunt;
		fin_filas = nf+num_filas;
		do
		{
			c=filas[nf]+ini_c;
			bc=pos[b][c];
			nf++;
			if (bc>=0)
			{
				coste=coste_ter+costeB1[c][b]+costeU[c];
				if (coste<coste_min)
				{
					c_min=c;
					coste_min=coste;
				}
			}
		}
		while (nf<fin_filas);
	}

	return c_min;
}


unsigned char calcular_sim (mejor_extension_cota g_amp, int sol[N])
{
	short i,a,b,c,coste_min;

	eliminar_variable_sim_n (g_amp);
	for (i=N-1;i>=N/2+2;i--)
	{
		eliminar_variable_sim (i,g_amp);
	}
	coste_min=encontrar_mejores_2_filas_centrales_sim (g_amp,&a,&b);

	sol[N/2-1]=a;
	sol[N/2]=b;
	for (i=N/2+1;i<N-1;i++) // N/2-1 .. N-4
	{
		c=recup_sol (i,a,b,true,g_amp);
		sol[i]=c;
		a=b;
		b=c;
	}
	c=recup_sol_n (a,b);
	sol[N-1]=c;
	a=sol[N/2];
	b=sol[N/2-1];
	for (i=N/2-2;i>0;i--)
	{
		c=recup_sol (i,a,b,false,g_amp);
		sol[i]=c;
		a=b;
		b=c;
	}
	c=recup_sol_n (a,b);
	sol[0]=c;

	for (i=0;i<N;i++)
	{
		sol[i]=sol[i]&((1<<(N>>1))-1);
		sol[i]=sol[i]+(invertir(sol[i],N>>1)<<(N>>1));
	}

	return coste_min;
}
